--[[
@title curves
@param   a Rauschreduzierung    0=aus
@default a 1
@param   f Tastaturverzgerung [ms]
@default f 40
@param   b Konsolenbreite    0=def=25
@default b 0
@param   c Konsolenzeilen 0=default=5
@default c 0
@param   d Taste zum beenden   0=nein
@default d 1
@param   e Kontrollmeldungen    0=aus
@defaul  e 0
@param   g Dateibeschreibungen  0=aus
@defaul  g 0
]]
  
  -- Ver 0.7
  ---------- globals for pad equ to size of con
conwidth_=25
conheight_=5

init_path     = "A/CHDK/CURVES"
files_to_read = ".CVF "
cfg_name      = "CURVES.DTA" 
cfg_file      = "A/CHDK/DATA/"..cfg_name
curve_name    = "STD.CVF"
curve_file    =  init_path.."/"..curve_name
curve_list    = "curve.lst"
curve_filelist=  init_path.."/"..curve_list


key=""

if b~=0 then
  conwidth=b
  if conwidth<10 then conwidth=10 end
  if conwidth>50 then conwidth=50 end
else conwidth=conwidth_ end  

if c~=0 then
  conheight=c
  if conheight<3 then conheight=3 end
  if conheight>25 then conheight=25 end
else conheight=conheight_ end

padheight=conheight-1

function button(allowed)
  repeat
    lastkey=key
    test=string.lower(key)
    sleep(f)
    if test~="" and is_pressed(test) then
    else
      key=""
      wait_click(f)
    end
    if     is_pressed "set"        then key = "SET"
    elseif is_pressed "erase"      then key = "ERASE"
    elseif is_pressed "menu"       then key = "MENU"
    elseif is_pressed "shoot_half" then key = "SET"
    elseif is_pressed "up"         then key = "UP"
    elseif is_pressed "down"       then key = "DOWN"
    elseif is_pressed "left"       then key = "LEFT"
    elseif is_pressed "right"      then key = "RIGHT"
    elseif is_pressed "zoom_in"    then key = "ZOOM_IN"
    elseif is_pressed "zoom_out"   then key = "ZOOM_OUT"
    end
    if allowed~=nil then if not string.find(allowed,key) then key="" end end
  until  key~=""
  set_led (8,1)
  sleep (5)
  set_led (8,0)
  sleep(5)
end

function waitpress()
  keysav,lastsav=key,lastkey
  button()
  key,lastkey=keysav,lastsav
end

function msg(title)
  return selection(title)
end

function get_state(file_name)
  state_is = {}
  local r = os.stat(file_name)
  if r then
    local keys={ "dev", "mode", "size", "atime", "mtime",
       "ctime", "blksize", "blocks", "attrib","is_dir","is_file",}
    for k,v in ipairs(keys) do
      state_is[v] = r[v]
    end
  end
  return state_is
end

function exists_file(name)
   local state_is=get_state(name)
   if state_is.attrib==nil then return false end
   return bitand(state_is.attrib,0x30) == 0x20
--   return state_is.is_file == true 
end   
     
function read_dir(path,files_to_find,only_names)
  local dir,state_is={},{}
  dir = os.listdir(path, true)
  table.sort(dir)
  ii=1
  if only_names then conw=-1 else conw=15 end
  while ii<=#dir do
    name  = dir[ii]
    test = name
    state_is=get_state(path.."/"..name)    
    if name=="." or name==curve_name or state_is.is_dir==nil then
      table.remove(dir,ii)
      ii=ii-1
    else
      if state_is.is_dir == true then
        size = "<dir>"
        test = size
      elseif state_is.is_file == true then
        size = tostring(state_is.size/1024).." kB"
      else
        size = "--"
      end
      if files_to_find~=nil 
      and not string.find(files_to_find,string.sub(string.upper(test),-4,-1)) then
          table.remove(dir,ii)
          ii=ii-1
      else
        dir[ii]=" "..string.sub(name..string.rep(" ",conw),1,conw)
        if not only_names then dir[ii]=dir[ii].."|"..size end
      end
    end
    ii=ii+1
  end
  return dir
end

function setidx(val,min,max,step)
  if step>=0 then
    if val+step<max then return val+step end
  else 
    max,min=min,max 
    if val+step>max then return val+step end 
  end
  if val==max then return min end
  return max
end

function selection(selection_table)
  local pad,ii,size,index,top,start={}
  size=table.getn(selection_table)
  for ii=1,size do
    table.insert(pad,string.sub(selection_table[ii]..string.rep(" ",50),1,conwidth))
  end
  start=1
  while string.sub(pad[start],1,1)~=" " do start=start+1 end 
  index,top=start,start
  repeat
    cls()
    for ii=1,start-1 do print(pad[ii]) end
    for ii=top,top+conheight-start do
      if ii==index then print("\16"..string.sub(pad[ii],2,-2).."\17")
      elseif ii>size then print(" ") else print(pad[ii]) end
    end
    if start>size then key="SET"
    else button() end
    if     key == "UP"    then index=setidx(index,start,size,-1)
    elseif key == "DOWN"  then index=setidx(index,start,size, 1)
    elseif key == "LEFT"  then index=setidx(index,start,size,-padheight)
    elseif key == "RIGHT" then index=setidx(index,start,size, padheight)
    end
    top=index-(conheight-start)
    if top<2  then top=2 end
  until key == "SET" or key == "MENU"
  return index-(start-1),selection_table[index]
end

function trim(s) 
  local ss=s
  while string.sub(ss,-1,-1) == " " do ss=string.sub(ss,1,-2) end
  return ss
end

function read_cfg()
--  print(cfg_file)
--  button()
  if not exists_file(cfg_file) then return nil end
  local f,buffer=io.input(cfg_file,rb)
  buffer=f:read("*all")
  f:close()
  return buffer
end

function copy_to_std(name,from_name)
  local f,buffer
  if from_name==nil then 
    f,buffer=io.input(name,rb)
    buffer=f:read("*all")
    f:close()
  else
    buffer=string.rep("\0\16",4*1024) 
  end
  f=io.output(curve_file,wb)
  f:write(buffer)
  f:close()
  if e~=0 then
      f=io.input(curve_file,rb)
      testbuffer=f:read("*all")
      f:close()
      if buffer==testbuffer then selection({name,"und STD.CVF sind nach","kopieren gleich."," ok"})
      else selection({name,"und STD.CVF verschieden","KOPIERFEHLER"," ok"}) end
  end
  f=io.output(cfg_file,wa)
  buffer=string.gsub(name,init_path,"")
  f:write(buffer)
  f:close(f)
end

function check_std(test,param)
   local ss,se,act_param
  -- makes a lookup in chdk configuration
  -- returns -1 if configuration not found
  --          0 if test not found
  --          1,act_val if test found and param not found
  --          2,act_val if test found and param found
  if exists_file("A/chdk/cchdk.cfg") then
    local f,buffer=io.input("A/chdk/cchdk.cfg",rb)
    buffer=f:read("*all")
    f:close()
    ss,se=string.find(buffer,test)
    if ss~=nil then
      act_param=string.sub(buffer,se+1,string.find(buffer,"\0",se+1)-1)
--     print("--"..act_param.."--"..param.."--",#act_param)
--      button()
      if  act_param==param then
         return 2,act_param
      else
         return 1,act_param 
      end
    else
      return 0,nil
    end
  else 
--    selection({"Datei ".."A/chdk/cchdk.cfg","wurde nicht gefunden"," ok"})
    return -1,nil
  end 
end


function read_curves_list(filelist)
  if not exists_file(filelist) then return nil end
  if g==0 then return nil end
  local f,buffer=io.open(filelist),{}
  for line in f:lines() do
       line=string.gsub(string.gsub(line,'"',''),"\13","")
       descpos=string.find(line," ")
       if descpos~=nil then 
          table.insert(buffer,{ fname=string.upper(string.sub(line,1,descpos-1)),fdesc=string.sub(line,descpos)})
       end
  end
  return buffer
end

function set_description(list)
  local newlist,test,ii,jj,kk={},""
  for ii=1,#list do
    newlist[ii]=list[ii]
    if ii>1 and curves~=nil and g~=0 then 
      test=string.sub(string.upper(list[ii]),2) 
      for jj,kk in pairs(curves) do   
         if kk.fname==test then
            newlist[ii]=kk.fdesc
            break
         end
      end      
    end   
  end
  return newlist
end

function set_pad(path,files_to_read)
    local pad,act_set=read_dir(path,files_to_read,true)
    act_set=read_cfg()
    if act_set==nil then act_set="Keine Kurve gesetzt" end
    table.insert(pad,1,act_set)
    table.insert(pad,2," Kurve aus")
    table.insert(pad,3," Kurve ein")
    return pad
end    


-- curve_state_sav=get_curve_state()
raw_nr_sav=get_raw_nr() 

function restore()
--	set_curve_state(curve_state_sav)
	set_raw_nr(raw_nr_sav)
end

newpath=""

------- start main
if not exists_file(curve_file) then
   if  exists_file("A/CHDK/syscurves.cvf") then
      copy_to_std("A/CHDK/syscurves.cvf")
   else
      copy_to_std("A/CHDK/syscurves.cvf",1)
   end      
end
--print (check_std(init_path,"/"..curve_name))
--button()
if check_std(init_path,"/"..curve_name)<2 then
   print("Zuerst die STD.CVF ueber")
   print("CHDK-Menue > ")
   print("Tonwertkurven ")
   print("Lade Kurvenprofil..laden")
   sleep(3000)
else
  if true then
--  if get_mode() then
    curves=read_curves_list(curve_filelist)
    repeat
      print("Liste wird erstellt")
      dir_list=set_pad(init_path..newpath,files_to_read)
      pad=set_description(dir_list)
      wahl,act_set=selection(pad)
      if key=="MENU" then
        pad=read_dir(init_path,"DIR> ",true)
        if #pad<2 then

           selection({"Es sind keine",
                      "Unterverzeichnisse",
                      "auf A/CHDK/CURVES",
                      "vorhanden.",
                      " [ok]"})
                      
        else              
--        table.insert(pad,1,"Verz: "..init_path)
          if pad[1]~=" .." then            
             table.insert(pad,1,"Verz: "..init_path)
          else  
            pad[1]="Verz: "..init_path
          end 
          wahl,act_set=selection(pad)
          if key=="SET" then
            newpath="/"..string.sub(act_set,2)
          else newpath="" end  
        end  
        key="MENU"
      else   
        cls()
        if wahl>2 then
          copy_to_std(init_path..newpath.."/"..string.sub(dir_list[wahl+1],2))
        else
          act_set=pad[1]
        end  
        if wahl==1 then
          set_curve_state(0)
          if a~=0 then set_raw_nr(0) end -- noise_reduction=ON 
          print("Kurve AUS geschaltet!")
        else
          set_curve_state(1)
          if a~=0 then set_raw_nr(2) end -- noise_reduction=AUTO 
          print("Kurve  EIN geschaltet!")
        end 
        print() 
        print(act_set)
      end
    until key=="SET"  
  else
    print("! Schalte auf FotoModus !")
    print("! und starte nochmal    !")
  end
  sleep(1000)
  if d~=0 then 
    print("[ ok ]")
    waitpress() 
  end
  cls()
  exit_alt()
end  

